/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

/* Copyright (C) 2004 
 *
 * Authors: Erik Eliasson <eliasson@it.kth.se>
 *          Johan Bilien <jobi@via.ecp.fr>
*/

#ifndef MIKEYMESSAGEDH_H
#define MIKEYMESSAGEDH_H

#include<libmikey/MikeyMessage.h>
#include<libmikey/MikeyPayload.h>
#include<libmikey/MikeyPayloadHDR.h>
#include<libmikey/MikeyPayloadT.h>
#include<libmikey/MikeyPayloadRAND.h>
#include<libmikey/MikeyPayloadCERT.h>
#include<libmikey/MikeyPayloadID.h>
#include<libmikey/MikeyPayloadDH.h>
#include<libmikey/MikeyPayloadSIGN.h>
#include<libmikey/MikeyPayloadERR.h>

//#include"../util/cert.h"
#include<libmikey/keyagreement_dh.h>

#define MAX_TIME_OFFSET 0xe1000000000LL //1 hour

class certificate;
class certificate_db;

class MikeyMessageDH : public MikeyMessage{
	public:
		MikeyMessageDH( KeyAgreementDH * key_agreement, unsigned int ssrc, unsigned int roc=0 );
		
		MikeyMessage * buildResponse( KeyAgreementDH * key_agreement );
		
		MikeyMessage * parseResponse( KeyAgreementDH * key_agreement );

		bool authenticate( KeyAgreement * );
};

#endif
