/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

/* Copyright (C) 2004 
 *
 * Authors: Erik Eliasson <eliasson@it.kth.se>
 *          Johan Bilien <jobi@via.ecp.fr>
*/

#ifndef MIKEYMESSAGEPSK_H
#define MIKEYMESSAGEPSK_H

#include<libmikey/MikeyMessage.h>
#include<libmikey/MikeyPayload.h>
#include<libmikey/MikeyPayloadHDR.h>
#include<libmikey/MikeyPayloadT.h>
#include<libmikey/MikeyPayloadRAND.h>
#include<libmikey/MikeyPayloadKEMAC.h>
#include<libmikey/MikeyPayloadV.h>
#include<libmikey/MikeyPayloadID.h>
#include<libmikey/MikeyPayloadERR.h>
#include<libmikey/MikeyException.h>
#include<libmikey/keyagreement_psk.h>

#define MAX_TIME_OFFSET 0xe1000000000LL //1 hour


class MikeyMessagePSK : public MikeyMessage{
	public:
		MikeyMessagePSK( KeyAgreementPSK * key_agreement,
				 unsigned int ssrc, unsigned int roc = 0, 
				 int encr_alg = MIKEY_ENCR_AES_CM_128,
				 int mac_alg = MIKEY_MAC_HMAC_SHA1_160 );
		
		MikeyMessage * buildResponse( KeyAgreementPSK * key_agreement );
		
		MikeyMessage * parseResponse( KeyAgreementPSK * key_agreement );

		bool authenticate( KeyAgreement * ka );

};

#endif
