/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

/* Copyright (C) 2004 
 *
 * Authors: Erik Eliasson <eliasson@it.kth.se>
 *          Johan Bilien <jobi@via.ecp.fr>
*/

#ifndef MIKEYPAYLOADDH_H
#define MIKEYPAYLOADDH_H

#include<libmikey/MikeyPayload.h>
#include<libmikey/keyvalidity.h>

#define MIKEYPAYLOAD_DH_PAYLOAD_TYPE 3

#define MIKEYPAYLOAD_DH_GROUP5 0
#define MIKEYPAYLOAD_DH_GROUP1 1
#define MIKEYPAYLOAD_DH_GROUP2 2


/**
 * @author Erik Eliasson, Johan Bilien
*/
class MikeyPayloadDH : public MikeyPayload{
	public:
		
		MikeyPayloadDH( int dhGroup, byte_t * dhKey, 
				KeyValidity * kv );
		MikeyPayloadDH( byte_t * start, int lengthLimit );
		~MikeyPayloadDH();

		virtual void writeData( byte_t * start, int expectedLength );
		virtual int length();
		virtual string debugDump();

		int group();
		byte_t * dhKey();
		int dhKeyLength();

		KeyValidity * kv();

	private:
		int dhGroup;
		int dhKeyLengthValue;
		byte_t * dhKeyPtr;
		KeyValidity * kvPtr;
		
};


#endif
